/*istanbul ignore next*/"use strict";

exports.__esModule = true;

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _values = require("babel-runtime/core-js/object/values");

var _values2 = _interopRequireDefault(_values);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

exports.default = function (fixturesLoc, name) {
  /*istanbul ignore next*/var suiteOpts = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];
  /*istanbul ignore next*/var taskOpts = arguments.length <= 3 || arguments[3] === undefined ? {} : arguments[3];
  /*istanbul ignore next*/var dynamicOpts = arguments[4];

  var suites = /*istanbul ignore next*/(0, _babelHelperFixtures2.default)(fixturesLoc);

  /*istanbul ignore next*/
  var _loop = function _loop() {
    if (_isArray) {
      if (_i >= _iterator.length) return "break";
      _ref = _iterator[_i++];
    } else {
      _i = _iterator.next();
      if (_i.done) return "break";
      _ref = _i.value;
    }

    var testSuite = _ref;

    if ( /*istanbul ignore next*/_lodash2.default.includes(suiteOpts.ignoreSuites, testSuite.title)) return (/*istanbul ignore next*/"continue"
      );

    suite(name + "/" + testSuite.title, function () {
      /*istanbul ignore next*/
      var _loop3 = function _loop3() {
        if (_isArray2) {
          if (_i2 >= _iterator2.length) return "break";
          _ref2 = _iterator2[_i2++];
        } else {
          _i2 = _iterator2.next();
          if (_i2.done) return "break";
          _ref2 = _i2.value;
        }

        var task = _ref2;

        if ( /*istanbul ignore next*/_lodash2.default.includes(suiteOpts.ignoreTasks, task.title) || /*istanbul ignore next*/_lodash2.default.includes(suiteOpts.ignoreTasks, testSuite.title + "/" + task.title)) return (/*istanbul ignore next*/"continue"
          );

        test(task.title, !task.disabled && function () {
          function runTask() {
            run(task);
          }

          /*istanbul ignore next*/_lodash2.default.defaults(task.options, {
            filenameRelative: task.expect.filename,
            sourceFileName: task.actual.filename,
            sourceMapTarget: task.expect.filename,
            suppressDeprecationMessages: true,
            babelrc: false,
            sourceMap: !!(task.sourceMappings || task.sourceMap)
          });

          /*istanbul ignore next*/_lodash2.default.extend(task.options, taskOpts);

          if (dynamicOpts) dynamicOpts(task.options, task);

          var throwMsg = task.options.throws;
          if (throwMsg) {
            // internal api doesn't have this option but it's best not to pollute
            // the options object with useless options
            delete task.options.throws;

            /*istanbul ignore next*/_assert2.default.throws(runTask, function (err) {
              return throwMsg === true || err.message.indexOf(throwMsg) >= 0;
            });
          } else {
            runTask();
          }
        });
      };

      /*istanbul ignore next*/
      _loop4: for ( /*istanbul ignore next*/var _iterator2 = testSuite.tests, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : (0, _getIterator3.default)(_iterator2);;) {
        /*istanbul ignore next*/
        var _ref2;

        var _ret3 = _loop3();

        switch (_ret3) {
          case "break":
            break _loop4;

          case "continue":
            continue;}
      }
    });
  };

  /*istanbul ignore next*/
  _loop2: for ( /*istanbul ignore next*/var _iterator = suites, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : (0, _getIterator3.default)(_iterator);;) {
    /*istanbul ignore next*/
    var _ref;

    var _ret2 = _loop();

    switch (_ret2) {
      case "break":
        break _loop2;

      case "continue":
        continue;}
  }
};

var /*istanbul ignore next*/_babelCore = require("babel-core");

/*istanbul ignore next*/
var babel = _interopRequireWildcard(_babelCore);

var /*istanbul ignore next*/_path = require("path");

/*istanbul ignore next*/
var _path2 = _interopRequireDefault(_path);

var /*istanbul ignore next*/_babelHelperFixtures = require("babel-helper-fixtures");

/*istanbul ignore next*/
var _babelHelperFixtures2 = _interopRequireDefault(_babelHelperFixtures);

var /*istanbul ignore next*/_sourceMap = require("source-map");

/*istanbul ignore next*/
var _sourceMap2 = _interopRequireDefault(_sourceMap);

var /*istanbul ignore next*/_babelCodeFrame = require("babel-code-frame");

/*istanbul ignore next*/
var _babelCodeFrame2 = _interopRequireDefault(_babelCodeFrame);

var /*istanbul ignore next*/_helpers = require("./helpers");

/*istanbul ignore next*/
var helpers = _interopRequireWildcard(_helpers);

var /*istanbul ignore next*/_assert = require("assert");

/*istanbul ignore next*/
var _assert2 = _interopRequireDefault(_assert);

var /*istanbul ignore next*/_chai = require("chai");

/*istanbul ignore next*/
var _chai2 = _interopRequireDefault(_chai);

var /*istanbul ignore next*/_lodash = require("lodash");

/*istanbul ignore next*/
var _lodash2 = _interopRequireDefault(_lodash);

/*istanbul ignore next*/require("babel-polyfill");

var /*istanbul ignore next*/_babelRegister = require("babel-register");

/*istanbul ignore next*/
var _babelRegister2 = _interopRequireDefault(_babelRegister);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* global test */
/* global suite */

/*istanbul ignore next*/(0, _babelRegister2.default)({
  ignore: [/*istanbul ignore next*/_path2.default.resolve(__dirname + "/../.."), "node_modules"]
});

var babelHelpers = eval( /*istanbul ignore next*/(0, _babelCore.buildExternalHelpers)(null, "var"));

function wrapPackagesArray(type, names) {
  return (names || []).map(function (val) {
    if (typeof val === "string") val = [val];
    val[0] = __dirname + "/../../babel-" + type + "-" + val[0];
    return val;
  });
}

function run(task) {
  var actual = task.actual;
  var expect = task.expect;
  var exec = task.exec;
  var opts = task.options;

  function getOpts(self) {
    var newOpts = /*istanbul ignore next*/_lodash2.default.merge({
      filename: self.loc
    }, opts);

    newOpts.plugins = wrapPackagesArray("plugin", newOpts.plugins);
    newOpts.presets = wrapPackagesArray("preset", newOpts.presets).map(function (val) {
      return val[0];
    });

    return newOpts;
  }

  var execCode = exec.code;
  var result = /*istanbul ignore next*/void 0;

  if (execCode) {
    var execOpts = getOpts(exec);
    result = babel.transform(execCode, execOpts);
    execCode = result.code;

    try {
      runExec(execOpts, execCode);
    } catch (err) {
      err.message = exec.loc + ": " + err.message;
      err.message += /*istanbul ignore next*/(0, _babelCodeFrame2.default)(execCode);
      throw err;
    }
  }

  var actualCode = actual.code;
  var expectCode = expect.code;
  if (!execCode || actualCode) {
    result = babel.transform(actualCode, getOpts(actual));
    actualCode = result.code.trim();

    try {
      /*istanbul ignore next*/_chai2.default.expect(actualCode).to.be.equal(expectCode, actual.loc + " !== " + expect.loc);
    } catch (err) {
      //require("fs").writeFileSync(expect.loc, actualCode);
      throw err;
    }
  }

  if (task.sourceMap) {
    /*istanbul ignore next*/_chai2.default.expect(result.map).to.deep.equal(task.sourceMap);
  }

  if (task.sourceMappings) {
    /*istanbul ignore next*/
    (function () {
      var consumer = new /*istanbul ignore next*/_sourceMap2.default.SourceMapConsumer(result.map);

      /*istanbul ignore next*/_lodash2.default.each(task.sourceMappings, function (mapping) {
        var actual = mapping.original;

        var expect = consumer.originalPositionFor(mapping.generated);
        /*istanbul ignore next*/_chai2.default.expect({ line: expect.line, column: expect.column }).to.deep.equal(actual);
      });
    })();
  }
}

function runExec(opts, execCode) {
  var sandbox = /*istanbul ignore next*/(0, _extends3.default)({}, helpers, {
    babelHelpers: babelHelpers,
    assert: /*istanbul ignore next*/_chai2.default.assert,
    transform: babel.transform,
    opts: opts,
    exports: {}
  });

  var fn = /*istanbul ignore next*/new (Function.prototype.bind.apply(Function, [null].concat( /*istanbul ignore next*/(0, _keys2.default)(sandbox), [execCode])))();
  return fn.apply(null, /*istanbul ignore next*/(0, _values2.default)(sandbox));
}

/*istanbul ignore next*/module.exports = exports["default"];